#include "bj.h"

//unsigned char DrvJoy1[8] = {0, 0, 0, 0, 0, 0, 0, 0};
static unsigned char DrvReset = 0;

static struct BurnInputInfo DrvInputList[] = {
	{"P1 Coin",		0, DrvJoy1 + 0,	"p1 coin"},
	{"P1 Start",	0, DrvJoy1 + 1,	"p1 start"},


	{"P1 Up",		0, DrvJoy1 + 2, 	"p1 up"},
	{"P1 Down",		0, DrvJoy1 + 3, 	"p1 down"},
	{"P1 Left",		0, DrvJoy1 + 4, 	"p1 left"},
	{"P1 Right",	0, DrvJoy1 + 5, 	"p1 right"},
	{"P1 Button 1",	0, DrvJoy1 + 6,		"p1 fire 1"},


	{"Reset",		0, &DrvReset,		"reset"},
/*	{"Diagnostic",	0, DrvButton + 2,	"diag"},
	{"Dip A",		2, DrvInput + 3,	"dip"},
	{"Dip B",		2, DrvInput + 4,	"dip"},
	{"Dip C",		2, DrvInput + 5,	"dip"},
*/};

// Return 0 if a input number is defined, and (if pii != NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii, unsigned int i)
{
	if (i >= sizeof(DrvInputList) / sizeof(DrvInputList[0])) {
		return 1;
	}
	if (pii != NULL) {
		*pii=DrvInputList[i];
	}
	return 0;
}

// Count possible zip names and (if pszName!=NULL) return them
static int DrvZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="bombjack.zip";  return 0; }
  return 1;
}

static int Bj2DrvZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="bombjac2.zip";  return 0; }
  if (i==0) { if (pszName!=NULL) *pszName="bombjack.zip";  return 0; }

  return 1;
}
// Rom information
static struct { char szName[16]; int nLen; unsigned int nCrc; int nType; } DrvRomDesc[]=
{
  {"09_j01b.bin"	,0x2000,0xc668dc30, 2}, //  0 Z80 code
  {"10_l01b.bin"	,0x2000,0x52a1e5fb, 2}, //  1
  {"11_m01b.bin"	,0x2000,0xb68a062a, 2}, //  2
  {"12_n01b.bin"	,0x2000,0x1d3ecee5, 2}, //  3
  {"13.1r"			,0x2000,0x70e0244d, 2}, //  4

  // graphics 3 bit planes:
  {"03_e08t.bin"    ,0x1000,0x9f0470d5,    1},  // chars
  {"04_h08t.bin"    ,0x1000,0x81ec12e6,    1},
  {"05_k08t.bin"    ,0x1000,0xe87ec8b1,    1},

  {"14_j07b.bin"    ,0x2000,0x101c858d,    1},  // sprites
  {"15_l07b.bin"    ,0x2000,0x013f58f2,    1},
  {"16_m07b.bin"    ,0x2000,0x94694097,    1},

  {"06_l08t.bin"    ,0x2000,0x51eebd89,    1},   // background tiles
  {"07_n08t.bin"    ,0x2000,0x9dd98e9d,    1},
  {"08_r08t.bin"    ,0x2000,0x3155ee7d,    1},

  {"02_p04t.bin"    ,0x1000,0x398d4a02,    1}, // background tilemaps
};

// Return 0 if a rom number is defined, and (if pri!=NULL) information about each rom
static int DrvRomInfo(struct BurnRomInfo *pri,unsigned int i)
{
  if (i>=sizeof(DrvRomDesc)/sizeof(DrvRomDesc[0])) return 1; // Check i is in range
  // Return information about the rom
  if (pri!=NULL)
  {
    pri->nLen =DrvRomDesc[i].nLen;
    pri->nCrc =DrvRomDesc[i].nCrc;
    pri->nType=DrvRomDesc[i].nType;
  }
  return 0;
}

// Return possible names for rom number 'i'
static int DrvRomName(char **pszName,unsigned int i,int nAka)
{
  if (i>=sizeof(DrvRomDesc)/sizeof(DrvRomDesc[0])) return 1; // Check i is in range
  if (nAka!=0) return 1; // Roms known by one name
  *pszName=DrvRomDesc[i].szName;
  return 0;
}


struct BurnDriver BurnDrvBombjack=
{
  {"bombjack","Bomb Jack (set 1)","Preliminary Driver","Tehkan","Bomb Jack Hardware","1984",NULL},
  1,2,HARDWARE_SEGA_SYSTEM16B,
  DrvZipName,DrvRomInfo,DrvRomName,DrvInputInfo,
  BjInit,BjExit,BjFrame,NULL,BjScan,
  NULL,256,256,4,3
};

struct BurnDriver BurnDrvBombjack2=
{
  {"bombjac2","Bomb Jack (set 2)","Preliminary Driver","Tehkan","Bomb Jack Hardware","1984","bombjack"},
  1,2,HARDWARE_SEGA_SYSTEM16B,
  Bj2DrvZipName,DrvRomInfo,DrvRomName,DrvInputInfo,
  BjInit,BjExit,BjFrame,NULL,BjScan,
  NULL,256,256,4,3
};