#include "si.h"

unsigned char DrvJoy1[8] = {0, 0, 0, 0, 0, 0, 0, 0};
static unsigned char DrvReset = 0;

static struct BurnInputInfo DrvInputList[] = {
	{"P1 Coin",		0, DrvJoy1 + 0,		"p1 coin"},
	{"P1 Start 2",	0, DrvJoy1 + 1,		"p2 start"},
	{"P1 Start 1",	0, DrvJoy1 + 2, 	"p1 start"},
	{"P1 Unknown",	0, DrvJoy1 + 3, 	"p1 down"},
	{"P1 Button 1",	0, DrvJoy1 + 4, 	"p1 fire 1"},
	{"P1 Left",		0, DrvJoy1 + 5, 	"p1 left"},
	{"P1 Right",	0, DrvJoy1 + 6,		"p1 right"},
	{"P1 Unknown 1",0, DrvJoy1 + 7,		"p1 fire 2"},

//	{"Reset",		0, &DrvReset,		"reset"},

};

// Return 0 if a input number is defined, and (if pii != NULL) information about each input
static int DrvInputInfo(struct BurnInputInfo *pii, unsigned int i)
{
	if (i >= sizeof(DrvInputList) / sizeof(DrvInputList[0])) {
		return 1;
	}
	if (pii != NULL) {
		*pii=DrvInputList[i];
	}
	return 0;
}

// Count possible zip names and (if pszName!=NULL) return them
static int DrvZipName(char **pszName,unsigned int i)
{
  if (i==0) { if (pszName!=NULL) *pszName="invaders.zip";  return 0; }
  return 1;
}

// Rom information
static struct { char szName[16]; int nLen; unsigned int nCrc; int nType; } DrvRomDesc[]=
{
	{"invaders.h",0x0800, 0x734f5ad8,2},
	{"invaders.g",0x0800, 0x6bfaca4a,2},
	{"invaders.f",0x0800, 0x0ccead96,2},
	{"invaders.e",0x0800, 0x14e538b0,2},
};

// Return 0 if a rom number is defined, and (if pri!=NULL) information about each rom
static int DrvRomInfo(struct BurnRomInfo *pri,unsigned int i)
{
  if (i>=sizeof(DrvRomDesc)/sizeof(DrvRomDesc[0])) return 1; // Check i is in range
  // Return information about the rom
  if (pri!=NULL)
  {
    pri->nLen =DrvRomDesc[i].nLen;
    pri->nCrc =DrvRomDesc[i].nCrc;
    pri->nType=DrvRomDesc[i].nType;
  }
  return 0;
}

// Return possible names for rom number 'i'
static int DrvRomName(char **pszName,unsigned int i,int nAka)
{
  if (i>=sizeof(DrvRomDesc)/sizeof(DrvRomDesc[0])) return 1; // Check i is in range
  if (nAka!=0) return 1; // Roms known by one name
  *pszName=DrvRomDesc[i].szName;
  return 0;
}


struct BurnDriver BurnDrvInvaders=
{
  {"invaders","Space Invaders","Preliminary Driver","Midway","Bomb Jack Hardware","1978",NULL},
  1,2,HARDWARE_SEGA_SYSTEM16B,
  DrvZipName,DrvRomInfo,DrvRomName,DrvInputInfo,
  SiInit,SiExit,SiFrame,NULL,SiScan,
  NULL,256,256,4,3
};


