#include "si.h"
unsigned char *SiRom =NULL; unsigned int nSiRomLen =0; 
unsigned char *SiRam =NULL; unsigned int nSiRamLen =0; 
unsigned char shiftdat1,shiftdat2,shiftamount;
// Z80 accesses

static unsigned char SiZIn(unsigned short addr)
{
	if (addr <= 2) 
	{
		unsigned char temp=0x01;
		if (DrvJoy1[0])
			temp^=0x01;
		if (DrvJoy1[1])
			temp|=0x02;
		if (DrvJoy1[2])
			temp|=0x04;
		if (DrvJoy1[4])
			temp|=0x10;
		if (DrvJoy1[5])
			temp|=0x20;
		if (DrvJoy1[6])
			temp|=0x40;
		return temp;
	}
	if (addr == 0x0003)
	{
		return (((((shiftdat1 << 8) | shiftdat2) << (shiftamount & 0x07)) >> 8) & 0xff)|0xF;
	}
    return 0;
}

static void SiZOut(unsigned short addr,unsigned char val)
{
	if (addr==0x02)
	{
	shiftamount = val;
	}
	if (addr==0x03)
	{
        shiftdat2=shiftdat1;
        shiftdat1=val;
	}
}

unsigned char SiMemRead(unsigned short addr)
{
	return SiRam[addr];
}

static void SiMemWrite(unsigned short addr,unsigned char val)
{
		SiRam[addr]=val;
}


int SiZInit()
{
	ZetIn=SiZIn; 
	ZetOut=SiZOut;
	ZetRead=SiMemRead; 
	ZetWrite=SiMemWrite;
	ZetInit();
	ZetMapArea    (0x0000,0x1fff,0,SiRom+0x0000); // Direct Read from ROM
	ZetMapArea    (0x0000,0x1fff,2,SiRom+0x0000); // Direct Fetch from ROM
	ZetMapArea    (0x2000,0xffff,2,SiRam+0x2000); 
	ZetMemEnd();
    // remember to do ZetReset() in main driver
     return 0;
}

int SiInit()
{
	nSiRamLen=0xffff;
    SiRam=(unsigned char *)malloc(nSiRamLen);
    if (SiRam==NULL) return 1;
    memset(SiRam,0x11,nSiRamLen);

	nSiRomLen=0x2000;
    SiRom=(unsigned char *)malloc(nSiRomLen);
    if (SiRom==NULL) return 1;
    memset(SiRom,0x22,nSiRomLen);

	for (int i =0; i<4 ; i++)
	{
		BurnLoadRom(SiRom+(0x0800*i),i,1); // load code roms
	}
	SiZInit();

	return 0;
}

int SiExit()
{
	if (SiRom!=NULL) 
		free(SiRom);
	SiRom=NULL;
	if (SiRam!=NULL) 
		free(SiRam);
	SiRam=NULL;
	ZetExit();
	ZetRead=NULL; ZetWrite=NULL;
	ZetIn=NULL; ZetOut=NULL;
	return 0;
}

void SiDraw()
{
	int x,y,yy,addr=0x2400;
	unsigned char byte;
	unsigned char *temp;


	for (addr=0x2400;addr<0x4000;addr++)
	{
		byte=SiRam[addr];
		x=(addr-0x2400)>>5;
		y=(0x4000-addr)&0x1F;
		y<<=3;
		y-=3;
		for (yy=8;yy>0;yy--)
		{
			temp=pBurnDraw + (nBurnPitch * y)+(nBurnBpp * x)+(nBurnPitch * yy);
			PutPix(temp,0xFFFFFF*(byte&1));
			byte>>=1;
		}
	}

}

int poo=0;

int SiFrame()
{
// Note: without interrupts happing here we will not get any "sprites"
	static int count;
	ZetRun(2000000/120);

	count++;
	if (count & 1)
		ZetRaiseIrq(0x08);  /* RST 08h */
	else
		ZetRaiseIrq(0x10);  /* RST 10h */

	ZetRun(2000000/120);
	if (pBurnDraw != NULL ) 
	{
		SiDraw();	
	}
	count++;
	if (count & 1)
		ZetRaiseIrq(0x08);  /* RST 08h */
	else
		ZetRaiseIrq(0x10);  /* RST 10h */

	if (count > 150)
	{

	}

	return 0;
}


int SiScan(int nAction,int *pnMin)
{
	return 0;
}




